//----------------------------------------------------------------------------------
//		kŋߗוωtB^
//----------------------------------------------------------------------------------
#include <windows.h>
#include "filter.h"
#include <algorithm>
#include <vector>

//---------------------------------------------------------------------
//		O[oϐ
//---------------------------------------------------------------------
static const PIXEL_YC YC_ZERO = {(short)0, (short)0, (short)0};

//---------------------------------------------------------------------
//		֐vg^Cv錾
//---------------------------------------------------------------------
static void set_smoothed(const FILTER * const &fp, const FILTER_PROC_INFO * const &fpip, std::vector<PIXEL_YC> &set, const int &k , const int &x, const int &y);
PIXEL_YC *ycp_edit(const FILTER_PROC_INFO * const &fpip, const int &x, const int &y);
PIXEL_YC *ycp_temp(const FILTER_PROC_INFO * const &fpip, const int &x, const int &y);
PIXEL_YC &yc_edit(const FILTER_PROC_INFO * const &fpip, const int &x, const int &y);
PIXEL_YC &yc_temp(const FILTER_PROC_INFO * const &fpip, const int &x, const int &y);
template<class T> T abs(const T &a);
template<class T> T min(const T &a, const T &b);

//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 2
TCHAR *track_name[TRACK_N] = {"͈", "k"};
int track_default[TRACK_N] = {     1,   4};
int track_s[TRACK_N]       = {     1,   2};
int track_e[TRACK_N]       = {     3,  49};

#define CHECK_N 1
TCHAR *check_name[CHECK_N] = {"F̂ݕω"};
int check_default[CHECK_N] = {               0};

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION,
	0,0,
	"kŋߗוωtB^",
	TRACK_N,
	track_name,
	track_default,
	track_s,track_e,
	CHECK_N,
	check_name,
	check_default,
	func_proc,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,NULL,
	NULL,
	0,
	"kŋߗוωtB^ ver20081026 by KAZOON",
	NULL,
	NULL,
};


//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable(void)
{
	return &filter;
}


//---------------------------------------------------------------------
//		tB^֐
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
	int t = fp->track[0];
	int area = 4*t*t+4*t+1;
	int k = min(fp->track[1], area);
	int x, y, i, xx, yy;
	std::vector<PIXEL_YC> set;
	BOOL xs, ys, xe, ye;

	for (y=0; y<fpip->h; y++) {
		ys = y < t;
		ye = y >= fpip->h-t;
		for (x=0; x<fpip->w; x++) {
			xs = x < t;
			xe = x >= fpip->w-t;
			i = 0;
			for (yy=(ys ? -y : -t); yy<=(ye ? fpip->h-1-y : t); yy++) {
				for (xx=(xs ? -x : -t); xx<=(xe ? fpip->w-1-x : t); xx++) {
					set.push_back(yc_edit(fpip, x+xx, y+yy) - yc_edit(fpip, x, y));
					i++;
				}
			}
			set_smoothed(fp, fpip, set, (i!=area ? (k*i/area==0 ? 1 : k*i/area) : k), x, y);
		}
	}
	std::swap(fpip->ycp_edit, fpip->ycp_temp);

	return TRUE;
}

//---------------------------------------------------------------------
static void set_smoothed(const FILTER * const &fp, const FILTER_PROC_INFO * const &fpip, std::vector<PIXEL_YC> &set, const int &k , const int &x, const int &y){
	int i, y_sum, cb_sum, cr_sum;

	y_sum = 0;
	cb_sum = 0;
	cr_sum = 0;
	nth_element(set.begin(), set.begin()+k-1, set.end());
	for (i=0; i<k; i++) {
		y_sum += set[i].y;
		cb_sum += set[i].cb;
		cr_sum += set[i].cr;
	}
	set.clear();
	ycp_temp(fpip, x, y)->y = (fp->check[0] ? (short)0 : y_sum/k);
	ycp_temp(fpip, x, y)->cb = cb_sum/k;
	ycp_temp(fpip, x, y)->cr = cr_sum/k;
	yc_temp(fpip, x, y) += yc_edit(fpip, x, y);
}
PIXEL_YC *ycp_edit(const FILTER_PROC_INFO * const &fpip, const int &x, const int &y)
{
	return fpip->ycp_edit + x + fpip->max_w*y;
}
PIXEL_YC *ycp_temp(const FILTER_PROC_INFO * const &fpip, const int &x, const int &y)
{
	return fpip->ycp_temp + x + fpip->max_w*y;
}
PIXEL_YC &yc_edit(const FILTER_PROC_INFO * const &fpip, const int &x, const int &y)
{
	return fpip->ycp_edit[x + fpip->max_w*y];
}
PIXEL_YC &yc_temp(const FILTER_PROC_INFO * const &fpip, const int &x, const int &y)
{
	return fpip->ycp_temp[x + fpip->max_w*y];
}
template<class T> T abs(const T &a)
{
	return (a<0 ? -a : a);
}
template<class T> T min(const T &a, const T &b)
{
	return (a<b ? a : b);
}

//---------------------------------------------------------------------
//		o֐`
//---------------------------------------------------------------------
PIXEL_YC PIXEL_YC::operator+(const PIXEL_YC &other) const
{
	PIXEL_YC ret;

	ret.y = y + other.y;
	ret.cb = cb + other.cb;
	ret.cr = cr + other.cr;

	return ret;
}
PIXEL_YC &PIXEL_YC::operator+=(const PIXEL_YC &other)
{
	y += other.y;
	cb += other.cb;
	cr += other.cr;

	return *this;
}
PIXEL_YC PIXEL_YC::operator-(const PIXEL_YC &other) const
{
	PIXEL_YC ret;

	ret.y = y - other.y;
	ret.cb = cb - other.cb;
	ret.cr = cr - other.cr;

	return ret;
}
PIXEL_YC &PIXEL_YC::operator-=(const PIXEL_YC &other)
{
	y -= other.y;
	cb -= other.cb;
	cr -= other.cr;

	return *this;
}
BOOL PIXEL_YC::operator<(const PIXEL_YC &other) const
{
	if (abs(y) < abs(other.y)) {
		return TRUE;
	} else if (abs(y) == abs(other.y)) {
		if ((abs(cb)+abs(cr)) < (abs(other.cb)+abs(other.cr))) {
			return TRUE;
		} else {
			return FALSE;
		}
	} else {
		return FALSE;
	}
}
